C This program must be executed with 4 tasks.
C The rank 1 task uses the gather function to gather the result received form the other processes.
C The correct output should be:
C 0 0 204 204 408 408 612 612

      PROGRAM GATHER
      IMPLICIT NONE
      include 'mpif.h'
      INTEGER a(2,8), b(8), cpart(2), ctotal(8)
      INTEGER rank, size, i, k, root, ierr, scount, rcount
      call MPI_Init(ierr)
      call MPI_Comm_rank( MPI_COMM_WORLD, rank ,ierr)
      call MPI_Comm_size( MPI_COMM_WORLD, size ,ierr)
      root = 1
      if (size .NE. 4) then
         print *,'Error!:# of processors must be equal to 4'
         print *,'Programm aborting....'
         call MPI_Abort(MPI_COMM_WORLD, 1)
      endif
      DO 10 i=1,2
        DO 10 k=1,8
!          a(i,k)=rank*(k+1)
          a(i,k)=rank*(k)
10    CONTINUE
      scount = 2
      rcount = 8      
      do 15 k=1,8
!        b(k) = k+1
        b(k) = k
15    CONTINUE

      do 20 i=1,2
        cpart(i) = 0
        do 20 k=1,8
        cpart(i) = cpart(i) + a(i,k) * b(k)
20    CONTINUE
       call MPI_Gather(cpart,scount,MPI_INTEGER,ctotal,rcount,
     &    MPI_INTEGER,root, MPI_COMM_WORLD, ierr)

      if (rank.EQ.root) THEN
        do 25 k=1,8
        if(k.LT.8) print *, ctotal(k)
        if(k.EQ.8) print *, ctotal(k)
25      continue
      endif
      CALL MPI_Finalize(ierr);
      STOP
      END
