/* This program must be executed with 2 processes. It is a basic send-receive where a number is sent and then printed by
 *the receiving task. Why doesn't the output get printed? */

#include <stdio.h>
#include "mpi.h"
int main (int argc, char **argv)
{
     int rank, size, isbuf, ierr;
     int itag, myrank, irbuf;
     MPI_Init( &argc, &argv );
     MPI_Comm_rank( MPI_COMM_WORLD, &rank );
     MPI_Comm_size( MPI_COMM_WORLD, &size );
     MPI_Status status;
     isbuf=1;
     itag=1;
     if (myrank == 0){
       MPI_Send(&isbuf,1,MPI_INT,1,itag,MPI_COMM_WORLD);
     }
     else {
       printf(" rank =%d\n", myrank);
       MPI_Recv(&irbuf,1,MPI_INT,0,itag,MPI_COMM_WORLD,&status);
     }
     MPI_Finalize();
     return 0;
}
