# include <stdlib.h>
# include <stdio.h>

void junk_data ( void );
int main ( void );

/******************************************************************************/

int main ( void )

/******************************************************************************/
/*
 *   Purpose:
 *
 *       MAIN is the main program for TEST01.
 *
 *                         */
{
  printf ( "\n" );
  printf ( "TEST02:\n" );
  printf ( "  C version\n" );
  printf ( "  A sample code for analysis by VALGRIND.\n" );

  junk_data ( );
/*
 *   Terminate.
 *   */
  printf ( "\n" );
  printf ( "TEST02\n" );
  printf ( "  Normal end of execution.\n" );

  return 0;
}
/******************************************************************************/

void junk_data ( void )

/******************************************************************************/
{
  int i;
  int *x;

  x = ( int * ) malloc ( 10 * sizeof ( int ) );
/*
 *   X = { 0, 1, 2, 3, 4, ?a, ?b, ?c, ?d, ?e }.
 *   */
  for ( i = 0; i < 5; i++ )
  {
    x[i] = i;
  }
/*
 *   Copy some values.
 *     X = { 0, 1, ?c, 3, 4, ?b, ?b, ?c, ?d, ?e }.
 *     */
  x[2] = x[7];
  x[5] = x[6];
/*
 *   Modify some uninitialized entries.
 *     */
  for ( i = 0; i < 10; i++ )
  {
    x[i] = 2 * x[i];
  }
/*
 *   Print X.
 *   */
  for ( i = 0; i < 10; i++ )
  {
    printf ( "  %d  %d\n", i, x[i] );
  }

  free ( x );

  return;
}

